// Ping-Pong radio communication program
// T. Braunl, May 2017

#include "eyebot.h"
#define MAX 10

int main ()
{ int  i, size, my_id, partner;
  char buf[MAX];

  LCDMenu("","","","END");
  RADIOInit();
  my_id = RADIOGetID();
  LCDPrintf("my id %d\n", my_id);

  if (my_id==1)   // master only
  { partner=2;    // robot 1 --> robot 2
    RADIOSend(partner, "A");
  }
  else partner=1; // robot 2 --> robot 1
  
  for (i=0; i<10; i++)
  { size=RADIOReceive(&partner, buf, MAX);
    LCDPrintf("Received %d bytes from #%d: '%s' ", size, partner, buf);
    buf[0]++;  // increment first character of message
    LCDPrintf("-- Sending to #%d: '%s'\n", partner, buf);
    OSWait(100); // wait 0.25 sec.
    RADIOSend(partner, buf);
  }
  KEYWait(KEY4); // make sure window does not close
}

